#ifndef	_DFU_FP11_1X1_HEADER_INTERNAL_
#define _DFU_FP11_1X1_HEADER_INTERNAL_

void pb2lcd_ascii_text() {
#asm
	LOAD s8, CH_L;
	OUTPUT s8, LCD_00;
	LOAD s8, CH_M;
	OUTPUT s8, LCD_01;
	LOAD s8, CH_S;
	OUTPUT s8, LCD_02;
	LOAD s8, CH_space;
	OUTPUT s8, LCD_03;
	;
	LOAD s8, CH_space;
	OUTPUT s8, LCD_06;
	LOAD s8, CH_L;
	OUTPUT s8, LCD_07;
	LOAD s8, CH_equals;
	OUTPUT s8, LCD_08;
	;
	LOAD s8, CH_space;
	OUTPUT s8, LCD_0B;
	LOAD s8, CH_I;
	OUTPUT s8, LCD_0C;
	LOAD s8, CH_equals;
	OUTPUT s8, LCD_0D;
	;
	LOAD s8, CH_F;
	OUTPUT s8, LCD_10;
	LOAD s8, CH_P;
	OUTPUT s8, LCD_11;
	LOAD s8, CH_1;
	OUTPUT s8, LCD_12;
	LOAD s8, CH_1;
	OUTPUT s8, LCD_13;
	LOAD s8, CH_2;
	OUTPUT s8, LCD_14;
	LOAD s8, CH_4;
	OUTPUT s8, LCD_15;
	LOAD s8, CH_P;
	OUTPUT s8, LCD_16;
	LOAD s8, CH_0;
	OUTPUT s8, LCD_17;
	LOAD s8, CH_space;
	OUTPUT s8, LCD_18;
	LOAD s8, CH_open;
	OUTPUT s8, LCD_19;
	LOAD s8, CH_c;
	OUTPUT s8, LCD_1A;
	LOAD s8, CH_close;
	OUTPUT s8, LCD_1B;
	LOAD s8, CH_U;
	OUTPUT s8, LCD_1C;
	LOAD s8, CH_T;
	OUTPUT s8, LCD_1D;
	LOAD s8, CH_I;
	OUTPUT s8, LCD_1E;
	LOAD s8, CH_A;
	OUTPUT s8, LCD_1F;
#endasm
}

void lms(unsigned char dh, unsigned char n, unsigned char op) {
#asm
	LOAD sD, sE;
	ADD sD, 01;
	FETCH sB, ( sD);//dh
	ADD sD,01;
	FETCH s1, ( sD);//n
	ADD sD,01;
	FETCH s3, ( sD);//op
	LOAD s2, 00;
	SUB s2, s1; //a=0-n
	LOAD s6, s2; //a
	OUTPUTK 00, PBP_REG01;//------------------------- instruction address 0 -----------
	OUTPUT s6, DFU_A_MEM_ADDR;
	OUTPUT s6, DFU_A_MEM_SADDR;
	OUTPUTK 00, DFU_B_MEM_ADDR;
	OUTPUTK 00, DFU_B_MEM_SADDR;
	OUTPUTK 00, DFU_Z_MEM_ADDR;
	OUTPUTK 00, DFU_Z_MEM_SADDR;
	OUTPUTK 00, DFU_Z_INC;
	OUTPUTK 01, DFU_A_INC;
	OUTPUTK 01, DFU_B_INC;
	OUTPUTK 00, DFU_A_MEM_BANK;
	OUTPUTK 00, DFU_B_MEM_BANK;
	OUTPUT sB, DFU_Z_MEM_BANK;
	LOAD s7, s1; //n
	LOAD s4, s7;
	SUB s7,01;
	OUTPUT s7, DFU_CNT;
	LOAD s5,00;
	_lms_loop1: ; //
	OUTPUT s3, DFU_OP; //dot product with wrap
	SUB s4, 01; //main loop counter decremented
	LOAD sA, s5; //prepare pointer to LMS error computation
	ADD s5, 01; //increment from where
	OUTPUTK 00, DFU_A_INC;
	OUTPUTK 00, DFU_B_INC;
	OUTPUTK 00, DFU_Z_INC;
	OUTPUTK 00, DFU_CNT;
	OUTPUT sB, DFU_A_MEM_BANK;
	OUTPUT sB, DFU_B_MEM_BANK;
	OUTPUT sB, DFU_Z_MEM_BANK;
	OUTPUTK FF, DFU_A_MEM_ADDR;
	OUTPUT sA, DFU_B_MEM_ADDR;
	OUTPUT sA, DFU_Z_MEM_ADDR;
	_lms_wait4hw_01: ;
	INPUT sC, PBP_REG02;
	OR sC, 00;
	JUMP Z, _lms_wait4hw_01;
	OUTPUTK DFU_OP_VSUB_BZ2A, DFU_OP;
	OUTPUTK 00, DFU_Z_MEM_BANK;
	OUTPUTK FF, DFU_A_MEM_ADDR;
	OUTPUTK FF, DFU_B_MEM_ADDR;
	OUTPUTK FF, DFU_Z_MEM_ADDR;
	_lms_wait4hw_02: ;
	INPUT sC, PBP_REG02;
	OR sC, 00;
	JUMP Z, _lms_wait4hw_02;
	OUTPUTK DFU_OP_VMULT_AZ2B, DFU_OP;
	OUTPUTK 01, DFU_A_MEM_BANK;
	_lms_wait4hw_03: ;
	INPUT sC, PBP_REG02;
	OR sC, 00;
	JUMP Z, _lms_wait4hw_03;
	OUTPUTK DFU_OP_VB2A, DFU_OP;
	OUTPUTK 00, DFU_A_INC;
	OUTPUTK 00, DFU_B_MEM_BANK;
	OUTPUTK 00, DFU_B_MEM_ADDR;
	OUTPUTK 01, DFU_B_INC;
	OUTPUTK 01, DFU_Z_INC;
	OUTPUTK 01, DFU_A_MEM_BANK;
	OUTPUTK 01, DFU_Z_MEM_BANK;
	OUTPUT s6, DFU_Z_MEM_ADDR;
	OUTPUT s4, DFU_CNT;
	_lms_wait4hw_04: ;
	INPUT sC, PBP_REG02;
	OR sC, 00;
	JUMP Z, _lms_wait4hw_04;
	OUTPUTK DFU_OP_VMULT, DFU_OP;
	COMPARE s4, s7;
	JUMP Z, _lms_stage0;
	OUTPUT s2, DFU_Z_MEM_ADDR;
	LOAD s8, s4;
	ADD s8,01;
	OUTPUT s8, DFU_B_MEM_ADDR;
	LOAD s8, s7;
	SUB s8, s4;
	SUB s8, 01;
	OUTPUT s8, DFU_CNT;
	_lms_wait4hw_05: ;
	INPUT sC, PBP_REG02;
	OR sC, 00;
	JUMP Z, _lms_wait4hw_05;
	OUTPUTK DFU_OP_VMULT, DFU_OP;
	_lms_stage0: ;
	OUTPUT s2, DFU_A_MEM_ADDR;
	OUTPUT s2, DFU_B_MEM_ADDR;
	OUTPUTK 01, DFU_B_MEM_BANK;
	OUTPUTK 01, DFU_A_INC;
	OUTPUTK 01, DFU_B_INC;
	OUTPUTK 00, DFU_A_MEM_BANK;
	OUTPUT s7, DFU_CNT;
	_lms_wait4hw_06: ;
	INPUT sC, PBP_REG02;
	OR sC, 00;
	JUMP Z, _lms_wait4hw_06;
	OUTPUTK DFU_OP_VA2B, DFU_OP;
	OUTPUT s2, DFU_A_MEM_ADDR;
	OUTPUT s2, DFU_B_MEM_ADDR;
	OUTPUT s2, DFU_Z_MEM_ADDR;
	OUTPUTK 00, DFU_A_MEM_BANK;
	OUTPUTK 01, DFU_B_MEM_BANK;
	OUTPUTK 01, DFU_Z_MEM_BANK;
	OUTPUTK 01, DFU_A_INC;
	OUTPUTK 01, DFU_B_INC;
	OUTPUTK 01, DFU_Z_INC;
	OUTPUT s7, DFU_CNT;
	_lms_wait4hw_07: ;
	INPUT sC, PBP_REG02;
	OR sC, 00;
	JUMP Z, _lms_wait4hw_07;
	OUTPUTK DFU_OP_VADD_BZ2A, DFU_OP;
	OUTPUTK 00, DFU_Z_INC;
	OUTPUTK 00, DFU_CNT;
	OUTPUTK 00, DFU_B_MEM_BANK;
	OUTPUTK 00, DFU_Z_MEM_BANK;
	OUTPUTK 01, DFU_A_INC;
	OUTPUTK 01, DFU_B_INC;
	OUTPUT sB, DFU_A_MEM_BANK;
	OUTPUT s4, DFU_B_MEM_ADDR; //location where to put data into B
	OUTPUT sA, DFU_A_MEM_ADDR; //location where to get data in A
	ADD s6, 01; //increment start of circular buffer in A
	COMPARE s4, 00; //test end of the loop
	JUMP Z, _lms_end;
	_lms_wait4hw_08: ;
	INPUT sC, PBP_REG02;
	OR sC, 00;
	JUMP Z, _lms_wait4hw_08;
	OUTPUTK DFU_OP_VA2B, DFU_OP; //copy data from A to B
	OUTPUTK 00, DFU_B_MEM_ADDR; //from addr 0 in B
	OUTPUTK 00, DFU_A_MEM_BANK; //set  bank 0 in A
	OUTPUT sB, DFU_Z_MEM_BANK;
	OUTPUT s5, DFU_Z_MEM_ADDR; //set address in Z
	OUTPUT s6, DFU_A_MEM_ADDR; //set address in A
	OUTPUT s7, DFU_CNT; //restore count
	_lms_wait4hw_09: ;
	INPUT sC, PBP_REG02;
	OR sC, 00;
	JUMP Z, _lms_wait4hw_09;
	JUMP _lms_loop1;
	_lms_end: ;
	_lms_wait4hw_10: ;
	INPUT sC, PBP_REG02;
	OR sC, 00;
	JUMP Z, _lms_wait4hw_10;
	OUTPUTK DFU_OP_VA2B, DFU_OP; //copy data from A to B
	_lms_wait4hw_11: ;
	INPUT sC, PBP_REG02;
	OR sC, 00;
	JUMP Z, _lms_wait4hw_11;
	; // end of lms
#endasm
}

#endif /* _DFU_FP11_1X1_HEADER_INTERNAL_ */ 
